
#property copyright ""
#property link      ""

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Yellow
#property indicator_width1  1
#property indicator_width2  1


extern int Fr.Period = 6;
extern int MaxBars = 500;


double upper_fr[];
double lower_fr[];
double cDy, dy = 0;

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

void init() {
  SetIndexBuffer(0, upper_fr);
  SetIndexBuffer(1, lower_fr);
  
  SetIndexEmptyValue(0, 0);
  SetIndexEmptyValue(1, 0);
  
  SetIndexStyle(0, DRAW_ARROW);
  SetIndexArrow(0, 234);
  SetIndexLabel(0, "iFracX Bu"); 

  SetIndexStyle(1, DRAW_ARROW);
  SetIndexArrow(1, 233);  
  SetIndexLabel(1, "iFracX Se");

  for (int i=1; i <= 20; i++) {
    dy += 0.3*(High[i]-Low[i])/20;
  }
  cDy = 0.007;


}

void start() 
{
  int counted = IndicatorCounted();
  if (counted < 0) return (-1);
  if (counted > 0) counted--;
  
  int i, limit = MathMin(Bars-counted, MaxBars);
  static double   qLastBuy, qLastSell;
  static datetime tLastBuy, tLastSell, lastBar=-1;
  static bool BuyAlert = false, SellAlert = false; 
  
  if ( lastBar != Time[0] ) {
		lastBar = Time[0];
		dy = cDy*(High[1] - Low[1] - dy) + dy;
		BuyAlert = false; SellAlert = false;
  }
    
  tLastBuy = -1; tLastSell = -1;
  //org  for (i=0+Fr.Period; i <= limit+Fr.Period; i++)  {
  for (i=0; i <= limit+Fr.Period; i++)  {
    upper_fr[i] = 0.0;
    lower_fr[i] = 0.0;
    if (i<Fr.Period) continue;
  
    if (is_upper_fr(i, Fr.Period)) { upper_fr[i] = High[i]+dy;  if (tLastBuy <0) {qLastBuy = High[i];  tLastBuy = Time[i];} }
    if (is_lower_fr(i, Fr.Period)) { lower_fr[i] =  Low[i]-dy;  if (tLastSell<0) {qLastSell = Low[i]; tLastSell = Time[i];} }
  }

  drawBreaks(qLastBuy, qLastSell);
  if ( Open[0] < qLastBuy && Close[0] >= qLastBuy && !BuyAlert ) {
		PlaySound("alert2.wav");
		BuyAlert = true;
  }
  if ( Open[0] > qLastSell && Close[0] <= qLastSell && !SellAlert ) {
		PlaySound("alert.wav");
		SellAlert = true;
  }
}

bool is_upper_fr(int bar, int period) 
{
  for (int i=1; i<=period; i++) 
  {
    if (bar+i >= Bars || bar-i < 0) return (false);

    if (High[bar] < High[bar+i]) return (false);
    if (High[bar] < High[bar-i]) return (false);
  }
  
  return (true);
}

bool is_lower_fr(int bar, int period) 
{
  for (int i=1; i<=period; i++) 
  {
    if (bar+i >= Bars || bar-i < 0) return (false);
    
    if (Low[bar] > Low[bar+i]) return (false);
    if (Low[bar] > Low[bar-i]) return (false);
  }
  
  return (true);
}

// tLastBuy,qLastBuy, tLastSell,qLastSell
int drawBreaks(double qB, double qS) {
	string id = "Break Buy (iFraX)";
	ObjectDelete(id);
	ObjectCreate(id, OBJ_TREND, 0, Time[2], qB, Time[0], qB);
	ObjectSet(id, OBJPROP_RAY, false);
	ObjectSet(id, OBJPROP_COLOR, Red);
	id = "Break Sell (iFraX)";
	ObjectDelete(id);
	ObjectCreate(id, OBJ_TREND, 0, Time[2], qS, Time[0], qS);
	ObjectSet(id, OBJPROP_RAY, false);
	ObjectSet(id, OBJPROP_COLOR, Yellow);
	return(0);
}